
//////////////////////////////////////////////
/// DialogClassSample
/// by Daniel Bartsch
/// 20/08/2003
//////////////////////////////////////////////

#include "stdafx.h"

LRESULT CALLBACK WndProc(HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam)																			
{
	switch (uMsg)									
	{
		case WM_COMMAND:
		{
			switch(LOWORD(wParam))
			{
				case ID_HELP_ABOUT:
				{
						CAboutDlg AboutDlg(IDD_ABOUT, hWnd);
						
						AboutDlg.DoModal(); /// display dialog
				}
				break;

				case ID_FILE_EXIT:
				{
						PostQuitMessage(0);					
						return 0;		
				}
				break;
			}
		}
		break;

		case WM_CLOSE:							
		{
			PostQuitMessage(0);					
			return 0;							
		}
		break;

	}

	return DefWindowProc(hWnd,uMsg,wParam,lParam);
}

HWND CreateMainWindow(void)
{
	WNDCLASS wc;
	memset(&wc, 0, sizeof(WNDCLASS));

	wc.style			= CS_HREDRAW | CS_VREDRAW;
	wc.lpfnWndProc		= (WNDPROC) WndProc;					
	wc.cbClsExtra		= 0;								
	wc.cbWndExtra		= 0;								
	wc.hInstance		= GetModuleHandle(NULL);						
	wc.hIcon			= LoadIcon(NULL, IDI_WINLOGO);			
	wc.hCursor			= LoadCursor(NULL, IDC_ARROW);			
	wc.hbrBackground	= (HBRUSH)GetStockObject(WHITE_BRUSH);								
	wc.lpszMenuName		= MAKEINTRESOURCE(IDR_MENU_MAIN);					
	wc.lpszClassName	= "WndClassName";

	if(!RegisterClass(&wc))									
	{
		MessageBox(NULL,"Failed To Register The Window Class.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return (NULL);								
	}

	HWND hWindow = CreateWindowEx(NULL, "WndClassName","DialogClassSample",WS_OVERLAPPEDWINDOW | WS_VISIBLE,0, 0, 320, 200, NULL, NULL, GetModuleHandle(NULL), NULL);
	
	return(hWindow);
}

int APIENTRY WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)                                                          
{
	HWND hWnd = CreateMainWindow();
 	
	MSG msg;
	BOOL bDone = FALSE;

	while(!bDone)									
	{
		if (PeekMessage(&msg,NULL,0,0,PM_REMOVE))	
		{
			if (msg.message==WM_QUIT)				
			{
				bDone = TRUE;						
			}
			else								
			{
				TranslateMessage(&msg);				
				DispatchMessage(&msg);		
			}
		}
	}

	return (msg.wParam);			
}



